#ifndef cDAG_GRAPH_HPP
#define cDAG_GRAPH_HPP

#include "cDAG_Types.hpp"

/* cDAG Datatypes */

struct vertex {
  int *adj; // array of adjacent vertexes
  int num_adj; // number of adjacent vertexes
  int alloc_adj; // number of allocated vertexes
  
  int num_rev; // number of edges pointing to me

  char type;
  void *args;
};

struct op {
	void (*func)(void* args, void* scratch_mem);
	int argsize;
};


struct graph {
  struct vertex* vertexes; // array of vertexes
  int num_vertexes; // number of used vertexes
  int alloc_vertexes; // number of preallocated vertexes
  int do_coll_detection; // whether to perform collectives detection or not (to avoid recursion within detection)
  int scratchpad_size; // size of scratchpad memory
  struct op* ops; // array of ops
  int num_ops; // how many operations are currently registered
  int alloc_ops; // number of preallocated operations
};

typedef struct graph* cDAG_Graph;

int add_vertex(cDAG_Graph g, char type, void* args);
int add_edge(cDAG_Graph g, int prereq, int target);

#endif
